WeaponWarn = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceEvent-2.0")
local self = WeaponWarn

WeaponWarn:RegisterDB("WeaponWarnDB")

function WeaponWarn:OnInitialize()
	self:RegisterEvent("ADDON_LOADED")
end

SLASH_WEAPONWARN1 = "/ww";
local function handler(msg, editbox)
 if msg and not (msg=="none" or msg=="off" or msg=="on" or msg=="help" or msg=="")
		then self.db.char.name = msg
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponWarn:|r Current Set |cff00ff00 %s|r", msg ))
	end
	if (msg=="none") then
		self.db.char.name = nil
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r Current Set |cffff0000 None|r")
	end
	if (msg=="off") then
		self.db.char.enable = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r |cffff0000Off|r")
	end
	if (msg=="on") then
		self.db.char.enable = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r |cff00ff00On|r")
	end
	if (msg=="help" or msg=="") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To specify an equipment set type /ww and the exact name of the set you want to use.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To not use an equipment set and display only a warning type /ww none.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To enable or disable type /ww on or /ww off.")
	end
end
SlashCmdList["WEAPONWARN"] = handler;


function WeaponWarn:ADDON_LOADED(event, addon)
	if addon == "WeaponWarn" then
		WeaponWarnDB = WeaponWarnDB
		self:SetScript( "OnUpdate", handler)
	end
end

function WeaponWarn:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
end
		
function WeaponWarn:PLAYER_REGEN_DISABLED()
	if (self.db.char.enable == false) then 
	return;
	else
		if (self.db.char.name == nil) and IsEquippedItemType("Fishing Poles") then
			RaidNotice_AddMessage( RaidBossEmoteFrame, "Fishing Pole Equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
			PlaySound("RaidBossEmoteWarning")
		end
		if self.db.char.name and IsEquippedItemType("Fishing Poles") then
			local ok = UseEquipmentSet(self.db.char.name)
			UseEquipmentSet(self.db.char.name)
			if ok then
				DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponWarn:|r Switched to Set |cff00ff00 %s|r", self.db.char.name ))
			else
				RaidNotice_AddMessage( RaidBossEmoteFrame, "Fishing Pole Equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r Invalid equipment set name. Could not equip.")
				PlaySound("RaidBossEmoteWarning")
			end
		end
		
		if (self.db.char.name == nil) and (IsEquippedItem("Argent Lance") or IsEquippedItem("Alliance Lance") or IsEquippedItem("Horde Lance")) and not UnitInVehicle("player") then
			RaidNotice_AddMessage( RaidBossEmoteFrame, "Jousting Lance Equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
			PlaySound("RaidBossEmoteWarning")
		end
		if self.db.char.name and (IsEquippedItem("Argent Lance") or IsEquippedItem("Alliance Lance") or IsEquippedItem("Horde Lance")) and not UnitInVehicle("player")then
			local ok = UseEquipmentSet(self.db.char.name)
			UseEquipmentSet(self.db.char.name)
			if ok then
				DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponWarn:|r Switched to Set |cff00ff00 %s|r", self.db.char.name ))
			else
				RaidNotice_AddMessage( RaidBossEmoteFrame, "Jousting Lance Equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r Invalid equipment set name. Could not equip.")
				PlaySound("RaidBossEmoteWarning")
			end
		end
	end
end